package com.bocloud.fms.booter.controller;

import com.bocloud.fms.intf.FlowVariableService;
import com.megatron.common.model.GeneralResult;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

;

/**
 * 流程参数变量
 *
 * @author zhangyf
 * @since 2020-09-02
 */
@RestController
@Tag(name = "流程参数变量")
@RequestMapping({"/v1/variables"})
public class FlowVariableController {

    @Autowired
    private FlowVariableService flowVariableService;

    /**
     * 流程参数变量列表
     *
     * @param type 流程参数变量类型
     * @return 流程参数变量列表
     */
    @GetMapping
    @Operation(summary = "流程参数变量列表")
    public GeneralResult list(String type) {
        return new GeneralResult(true, flowVariableService.listByType(type), "SUCCESS");
    }

}
