package com.bocloud.fms.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 附件
 *
 * @author zhangyf
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("attachment")
public class Attachment extends Generic implements Serializable {
    @IgnoreAll
    private static final long serialVersionUID = 9093802315920669872L;

    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 名称
     */
    @Column("name")
    private String name;

    @IgnoreUpdate
    @Column("creator_id")
    private Long creatorId;

    /**
     * 创建时间
     */
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    /**
     * 是否被删除
     */
    @Column("deleted")
    private Boolean deleted = false;

    /**
     * 附件组id
     */
    @Column("group_id")
    private String groupId;

    /**
     * 附件content-type
     */
    @Column("content_type")
    private String contentType;

    /**
     * 附件大小
     */
    @Column("size")
    private long size;

    /**
     * 附件相对路径
     */
    @Column("path")
    private String path;

}
