package com.bocloud.fms.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @author zhangyf 流程变量参数
 * @since 1.0
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Table("wf_variable")
public class FlowVariable extends Generic implements Serializable {

    /**
     * 主键ID
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 名称
     */
    @Column("name")
    private String name;
    /**
     * 类型
     */
    @Column("type")
    private String type;
    /**
     * 值
     */
    @Column("value")
    private String value;
    /**
     * 创建时间
     */
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;

    /**
     * 是否已删除 0 为删除 1 已删除
     */
    @Column("is_deleted")
    private Boolean deleted;
}
