package com.bocloud.fms.repository;

import com.megatron.framework.core.CurrentService;

import com.bocloud.fms.entity.Attachment;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Arrays;
import java.util.List;

@Repository("attachmentRepository")
public class AttachmentRepository extends BasicGenericDao<Attachment, Long> {

    public AttachmentRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    /**
     * 获取多个组内所有附件
     * @param groupIds 组ids
     * @return 附件list
     */
    public List<Attachment> list(String... groupIds) {
        try {
            String sql = "select * from attachment where deleted = 0 and group_id in (:groupIds) ";
            return this.list(Attachment.class, sql, MapTools.simpleMap("groupIds", Arrays.asList(groupIds)));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 批量保存附件
     * @param attachments 附件
     */
    public void saveAttachment(List<Attachment> attachments) {
        try {
            this.batchSave(attachments, 1000);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
