package com.bocloud.fms.repository;

import com.megatron.framework.core.CurrentService;



import com.bocloud.fms.entity.FlowNodeActor;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author hufy 任务参与者实体类
 * @since 1.0
 */
@Repository
public class FlowNodeActorRepository extends BasicGenericDao<FlowNodeActor, Long> {

    public FlowNodeActorRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    /**
     * 通过任务id获取参与者信息数据
     * @param taskId 任务id
     */
    public List<FlowNodeActor> getTaskActorsByTaskId(Long taskId) {
        String sql = "select * from wf_node_actor where node_id = :taskId";
        return this.list(FlowNodeActor.class, sql, MapTools.simpleMap("taskId", taskId));
    }

}
