package com.bocloud.fms.repository;

import com.megatron.framework.core.CurrentService;


import com.bocloud.fms.entity.FlowSequence;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 流程序列号Dao层实现类
 *
 * @author zhangdi
 * @since 2018/10/15
 */
@Repository
public class FlowSequenceRepository extends BasicGenericDao<FlowSequence, Long> {

    public FlowSequenceRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    /**
     * 通过日期查询流程序列号
     * @param date 日期
     * @return 流程序列号实体类
     */
    public FlowSequence query(String date) {
        String sql = "select * from wf_sequence where date = :date ";
        Map<String, Object> paramMap = MapTools.simpleMap("date", date);
        List<FlowSequence> list = this.list(FlowSequence.class, sql, paramMap);
        if (null == list || list.isEmpty()) {
            return null;
        }
        return list.get(0);
    }
}
