package com.bocloud.fms.repository;

import com.megatron.framework.core.CurrentService;


import com.bocloud.cos.entity.ServiceFlowConfig;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

/**
 * @author tyl
 * @time 2020/8/25 周二 10:54
 */
@Repository("serviceFlowConfigRepository")
public class ServiceFlowConfigRepository extends BasicGenericDao<ServiceFlowConfig, Long> {

    public ServiceFlowConfigRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    /**
     * 执行流程是否被服务绑定
     *
     * @param flowId 流程id
     * @return 是否被绑定
     */
    public boolean exists(Long flowId) {
        String sql = "select count(*) from service_flow_config a where a.flow_id=:flowId";
        return super.countQuery(sql, MapTools.simpleMap("flowId", flowId)) > 0;
    }

}
