package com.bocloud.fms.service.internal;

import com.bocloud.cmp.boot.model.BoCloudService;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.megatron.common.model.GeneralResult;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @author hufy
 */
@Component
public class FmsSmsProjectService {

    private final ServiceFactory serviceFactory;
    private final CurrentService currentService;

    @Autowired
    public FmsSmsProjectService(ServiceFactory serviceFactory, CurrentService currentService) {
        this.serviceFactory = serviceFactory;
        this.currentService = currentService;
    }

    private static final Service SERVICE = Service.create(BoCloudService.SMS.getName());

    /**
     * 项目下项目经理
     *
     * @param projectId 项目ID
     * @return 项目经理列表
     */
    public GeneralResult<?> listManagers(Long projectId) {
        Map<String, Object> headers = new HashMap<>(4);
        headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        return serviceFactory.build(SERVICE, "/v1/projects/" + projectId + "/managers", HttpMethod.GET, headers, null)
                .invoke();
    }

}
