package com.bocloud.fms.service.internal;


import com.bocloud.cmp.boot.model.BoCloudService;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Pager;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * soc角色
 *
 * @author liuyuanyuan
 */
@Component
public class FmsSmsRoleService implements InitializingBean {
    private final ServiceFactory serviceFactory;
    private final CurrentService currentService;

    @Autowired
    public FmsSmsRoleService(ServiceFactory serviceFactory, CurrentService currentService) {
        this.serviceFactory = serviceFactory;
        this.currentService = currentService;
    }

    private final Map<String, Object> headers = new HashMap<>(4);

    /**
     * 根据id获取角色信息
     *
     * @param id 角色id
     * @return
     */
    public GeneralResult detail(Long id) {
        RemoteService remoteService = serviceFactory.build(Service.create(BoCloudService.SMS.getName()),
                "/v1/roles/" + id, HttpMethod.GET, headers, null);
        return remoteService.invoke();
    }

    /**
     * 查询角色下用户
     *
     * @param roleId
     * @param pager
     * @return
     */
    public GeneralResult listUsers(Long roleId, Pager pager) {
        return serviceFactory.build(Service.create(BoCloudService.SMS.getName()), "/v1/roles/" + roleId + "/users", HttpMethod.GET, headers, pager.toMap()).invoke();
    }

    @Override
    public void afterPropertiesSet() {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
    }
}
